> ## Documentation Index
> Fetch the complete documentation index at: https://docs.crossmint.com/llms.txt
> Use this file to discover all available pages before exploring further.

# Remove Delegated Signer

> Remove an operational signer from a smart wallet.

**API scope required**: `wallets.create`



## OpenAPI

````yaml delete /2025-06-09/wallets/{walletLocator}/signers/{signer}
openapi: 3.0.0
info:
  title: Crossmint Wallets API
  description: Crossmint Wallets API
  version: 1.0.0
  contact:
    name: Crossmint Support
    url: https://www.crossmint.com
    email: support@crossmint.com
servers:
  - url: https://staging.crossmint.com/api
    description: Staging environment (testnets)
  - url: https://www.crossmint.com/api
    description: Production environment (mainnets)
security: []
tags: []
paths:
  /2025-06-09/wallets/{walletLocator}/signers/{signer}:
    delete:
      summary: Remove Delegated Signer
      description: |-
        Remove an operational signer from a smart wallet.

        **API scope required**: `wallets.create`
      operationId: WalletsV2025Controller-removeDelegatedSigner-2
      parameters:
        - name: X-API-KEY
          in: header
          description: API key required for authentication
          required: true
          schema:
            type: string
        - name: walletLocator
          required: true
          in: path
          description: >-
            A wallet locator can be of the format:

            - `<walletAddress>`

            - `email:<email>:<chainType>[:<walletType>][:alias:<alias>]`
            (walletType defaults to 'smart')

            - `userId:<userId>:<chainType>[:<walletType>][:alias:<alias>]`
            (white label user example)

            -
            `phoneNumber:<phoneNumber>:<chainType>[:<walletType>][:alias:<alias>]`

            - `twitter:<handle>:<chainType>[:<walletType>][:alias:<alias>]`

            - `x:<handle>:<chainType>[:<walletType>][:alias:<alias>]`

            - `me:<chainType>[:<walletType>][:alias:<alias>]` (Use when calling
            from the client side with a client API key)

            - `chainType[:<walletType>]:alias:<alias>`
          example:
            - '0x1234567890123456789012345678901234567890'
            - email:user@example.com:evm:smart
            - email:user@example.com:evm
            - email:user@example.com:evm:smart:alias:myWallet
            - userId:507f1f77bcf86cd799439011:solana:mpc
            - userId:did:example:cm4lr5piw0h6t1bjho0onryql:evm:smart
            - userId:507f1f77bcf86cd799439011:evm:alias:primary
            - phoneNumber:+12125551234:evm:smart
            - phoneNumber:+12125551234:evm:smart:alias:mobile
            - twitter:johndoe:evm:smart
            - x:@johndoe:evm:smart:alias:xWallet
            - me:evm:smart
            - me:evm:smart:alias:personal
            - evm:alias:myAlias
          schema:
            type: string
        - name: signer
          required: true
          in: path
          description: The locator for the signer
          example: external-wallet:0x1234567890123456789012345678901234567890
          schema:
            title: Signer Locator
            type: string
        - name: chain
          required: false
          in: query
          description: The chain to remove the signer from. Required for EVM wallets.
          schema:
            type: string
      responses:
        '200':
          description: The delegated signer removal has been initiated.
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/DelegatedSignerV2025Dto'
        '400':
          description: >-
            Returns an error if the signer cannot be removed (e.g. admin signer
            or unsupported wallet type)
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/WalletV1Alpha2ErrorDTO'
        '404':
          description: Returns an error if the wallet or signer not found
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/WalletV1Alpha2ErrorDTO'
components:
  schemas:
    DelegatedSignerV2025Dto:
      oneOf:
        - allOf:
            - discriminator:
                propertyName: type
              oneOf:
                - type: object
                  properties:
                    type:
                      type: string
                      enum:
                        - passkey
                      description: Identifier for the Passkey signer type
                    id:
                      type: string
                      description: Credential ID from the WebAuthn registration response
                    name:
                      type: string
                      description: Human-readable name for the passkey
                    publicKey:
                      type: object
                      properties:
                        x:
                          type: string
                          description: X coordinate of the public key as a decimal string
                        'y':
                          type: string
                          description: Y coordinate of the public key as a decimal string
                      required:
                        - x
                        - 'y'
                      description: The public key coordinates from the WebAuthn credential
                    validatorContractVersion:
                      type: string
                      description: ERC-7579 webAuthn validator contract version
                    locator:
                      type: string
                      description: Unique identifier for locating this passkey signer
                  required:
                    - type
                    - id
                    - name
                    - publicKey
                    - validatorContractVersion
                    - locator
                  description: >-
                    Response schema for a registered Passkey signer including
                    validator contract details
                  title: Passkey Signer
                  example:
                    type: passkey
                    id: cWtP7gmZbd98HbKUuGXx5Q
                    name: hgranger
                    publicKey:
                      x: >-
                        38035223810536273945556366218149112558607829411547667975304293530457502824247
                      'y': >-
                        91117823763706733837104303008228095481082989039135234750508288790583476078729
                    validatorContractVersion: 0.2.0
                    locator: passkey:cWtP7gmZbd98HbKUuGXx5Q
                - type: object
                  properties:
                    type:
                      type: string
                      enum:
                        - api-key
                      description: Identifier for API key signer type
                    address:
                      oneOf:
                        - type: string
                          description: An EVM address string
                        - type: string
                          description: A base58-encoded Solana public key address
                        - type: string
                      description: The blockchain address of the custodial signer
                    locator:
                      type: string
                      description: The locator of the signer
                  required:
                    - type
                    - address
                    - locator
                  title: API Key Signer
                  description: >-
                    Configuration for a custodial signer managed by Crossmint.
                    Contact sales (https://www.crossmint.com/contact/sales) for
                    access.
                  example:
                    type: api-key
                    address: '0x1234567890123456789012345678901234567890'
                    locator: api-key:0x1234567890123456789012345678901234567890
                - type: object
                  properties:
                    type:
                      type: string
                      enum:
                        - external-wallet
                      description: Identifier for external wallet signer type
                    address:
                      type: string
                      description: The blockchain address of the external wallet
                    locator:
                      type: string
                      description: The locator of the signer
                  required:
                    - type
                    - address
                    - locator
                  title: External Wallet Signer
                  description: Configuration for an external wallet signer
                  example:
                    type: external-wallet
                    address: '0x1234567890123456789012345678901234567890'
                    locator: external-wallet:0x1234567890123456789012345678901234567890
                - type: object
                  properties:
                    type:
                      type: string
                      enum:
                        - email
                      description: Identifier for email signer type
                    email:
                      type: string
                      description: The email address for the signer
                    locator:
                      type: string
                      description: The locator of the signer
                    address:
                      oneOf:
                        - type: string
                          description: An EVM address string
                        - type: string
                      description: The address of the signer
                  required:
                    - type
                    - email
                    - locator
                    - address
                  title: Email Signer
                  description: Configuration for an email signer
                  example:
                    type: email
                    email: user@example.com
                    locator: email:user@example.com
                    address: 0x1234567890abcdef...
                - type: object
                  properties:
                    type:
                      type: string
                      enum:
                        - phone
                      description: Identifier for phone signer type
                    phone:
                      type: string
                      description: The phone number for the signer in E164 format
                    locator:
                      type: string
                      description: The locator of the signer
                    address:
                      oneOf:
                        - type: string
                          description: An EVM address string
                        - type: string
                      description: The address of the signer
                  required:
                    - type
                    - phone
                    - locator
                    - address
                  title: Phone Signer
                  description: Configuration for a phone signer
                  example:
                    type: phone
                    phone: '+1234567890'
                    locator: phone:+1234567890
                    address: 0x1234567890abcdef...
                - type: object
                  properties:
                    type:
                      type: string
                      enum:
                        - device
                      description: Identifier for device signer type
                    publicKey:
                      type: object
                      properties:
                        x:
                          type: string
                          description: The x coordinate of the p256 public key
                        'y':
                          type: string
                          description: The y coordinate of the p256 public key
                      required:
                        - x
                        - 'y'
                      description: The p256 public key of the device signer
                    locator:
                      type: string
                      description: The locator of the signer
                  required:
                    - type
                    - publicKey
                    - locator
                  title: Device Signer
                  description: Configuration for a device signer
                  example:
                    type: device
                    publicKey:
                      x: decimal_string_x
                      'y': decimal_string_y
                    locator: device:BIVmCqMz8QJB+se2kJEpGQ...
              description: Response schema for a registered signer
            - type: object
              properties:
                transaction:
                  type: object
                  properties:
                    chainType:
                      type: string
                      enum:
                        - solana
                    onChain:
                      type: object
                      properties:
                        transaction:
                          type: string
                        lastValidBlockHeight:
                          type: number
                        txId:
                          type: string
                        explorerLink:
                          type: string
                      required:
                        - transaction
                    id:
                      type: string
                      description: Unique identifier for the transaction
                    status:
                      type: string
                      enum:
                        - awaiting-approval
                        - pending
                        - failed
                        - success
                      description: Current status of the transaction
                    approvals:
                      type: object
                      properties:
                        pending:
                          type: array
                          items:
                            type: object
                            properties:
                              signer:
                                discriminator:
                                  propertyName: type
                                oneOf:
                                  - type: object
                                    properties:
                                      type:
                                        type: string
                                        enum:
                                          - external-wallet
                                      address:
                                        type: string
                                        description: The address of the external wallet
                                      locator:
                                        type: string
                                        description: >-
                                          The locator of the external wallet
                                          signer
                                    required:
                                      - type
                                      - address
                                      - locator
                                    title: External Wallet Signer
                                    description: Full External Wallet signer object
                                  - type: object
                                    properties:
                                      type:
                                        type: string
                                        enum:
                                          - passkey
                                      id:
                                        type: string
                                        description: The ID of the passkey
                                      locator:
                                        type: string
                                        description: The locator of the passkey signer
                                    required:
                                      - type
                                      - id
                                      - locator
                                    title: Passkey Signer
                                    description: Full Passkey signer object
                                  - type: object
                                    properties:
                                      type:
                                        type: string
                                        enum:
                                          - api-key
                                      address:
                                        type: string
                                        description: The address of the api key
                                      locator:
                                        type: string
                                        description: The locator of the api key signer
                                    required:
                                      - type
                                      - address
                                      - locator
                                    title: API Key Signer
                                    description: Full API Key signer object
                                  - type: object
                                    properties:
                                      type:
                                        type: string
                                        enum:
                                          - device
                                      publicKey:
                                        type: object
                                        properties:
                                          x:
                                            type: string
                                          'y':
                                            type: string
                                        required:
                                          - x
                                          - 'y'
                                        description: The p256 public key of the device signer
                                      locator:
                                        type: string
                                        description: The locator of the device signer
                                    required:
                                      - type
                                      - publicKey
                                      - locator
                                    title: Device Signer
                                    description: Full Device signer object
                                  - type: object
                                    properties:
                                      type:
                                        type: string
                                        enum:
                                          - email
                                      email:
                                        type: string
                                        format: email
                                      locator:
                                        type: string
                                    required:
                                      - type
                                      - email
                                      - locator
                                  - type: object
                                    properties:
                                      type:
                                        type: string
                                        enum:
                                          - phone
                                      phone:
                                        type: string
                                      locator:
                                        type: string
                                    required:
                                      - type
                                      - phone
                                      - locator
                                description: The full signer object that's pending approval
                              message:
                                type: string
                                description: The message that needs to be signed
                            required:
                              - signer
                              - message
                          description: List of pending signatures
                        submitted:
                          type: array
                          items:
                            type: object
                            properties:
                              signature:
                                type: string
                                description: The cryptographic signature
                              submittedAt:
                                oneOf:
                                  - type: number
                                    description: ISO 8601 formatted timestamp
                                    example: '2024-01-01T00:00:00.000Z'
                                  - type: string
                                description: When the signature was submitted
                                example: '2024-01-01T00:00:00.000Z'
                              signer:
                                discriminator:
                                  propertyName: type
                                oneOf:
                                  - type: object
                                    properties:
                                      type:
                                        type: string
                                        enum:
                                          - external-wallet
                                      address:
                                        type: string
                                        description: The address of the external wallet
                                      locator:
                                        type: string
                                        description: >-
                                          The locator of the external wallet
                                          signer
                                    required:
                                      - type
                                      - address
                                      - locator
                                    title: External Wallet Signer
                                    description: Full External Wallet signer object
                                  - type: object
                                    properties:
                                      type:
                                        type: string
                                        enum:
                                          - passkey
                                      id:
                                        type: string
                                        description: The ID of the passkey
                                      locator:
                                        type: string
                                        description: The locator of the passkey signer
                                    required:
                                      - type
                                      - id
                                      - locator
                                    title: Passkey Signer
                                    description: Full Passkey signer object
                                  - type: object
                                    properties:
                                      type:
                                        type: string
                                        enum:
                                          - api-key
                                      address:
                                        type: string
                                        description: The address of the api key
                                      locator:
                                        type: string
                                        description: The locator of the api key signer
                                    required:
                                      - type
                                      - address
                                      - locator
                                    title: API Key Signer
                                    description: Full API Key signer object
                                  - type: object
                                    properties:
                                      type:
                                        type: string
                                        enum:
                                          - device
                                      publicKey:
                                        type: object
                                        properties:
                                          x:
                                            type: string
                                          'y':
                                            type: string
                                        required:
                                          - x
                                          - 'y'
                                        description: The p256 public key of the device signer
                                      locator:
                                        type: string
                                        description: The locator of the device signer
                                    required:
                                      - type
                                      - publicKey
                                      - locator
                                    title: Device Signer
                                    description: Full Device signer object
                                  - type: object
                                    properties:
                                      type:
                                        type: string
                                        enum:
                                          - email
                                      email:
                                        type: string
                                        format: email
                                      locator:
                                        type: string
                                    required:
                                      - type
                                      - email
                                      - locator
                                  - type: object
                                    properties:
                                      type:
                                        type: string
                                        enum:
                                          - phone
                                      phone:
                                        type: string
                                      locator:
                                        type: string
                                    required:
                                      - type
                                      - phone
                                      - locator
                                description: >-
                                  The full signer object who submitted this
                                  signature
                              message:
                                type: string
                                description: The message that was signed
                              metadata:
                                type: object
                                properties:
                                  deviceInfo:
                                    type: string
                                  ipAddress:
                                    type: string
                                  userAgent:
                                    type: string
                                description: >-
                                  Additional metadata about the signature
                                  submission
                            required:
                              - signature
                              - submittedAt
                              - signer
                              - message
                          description: Record of all submitted signatures
                        required:
                          type: number
                          description: Number of required approvals for the transaction
                      required:
                        - pending
                        - submitted
                      description: >-
                        Complete approval data including requirements, pending
                        and submitted signatures
                    createdAt:
                      oneOf:
                        - type: number
                          description: ISO 8601 formatted timestamp
                          example: '2024-01-01T00:00:00.000Z'
                        - type: string
                      description: ISO timestamp when the transaction was created
                      example: '2024-01-01T00:00:00.000Z'
                    completedAt:
                      oneOf:
                        - type: number
                          description: ISO 8601 formatted timestamp
                          example: '2024-01-01T00:00:00.000Z'
                        - type: string
                      description: ISO timestamp when the transaction reached finality
                      example: '2024-01-01T00:00:00.000Z'
                    error:
                      oneOf:
                        - type: object
                          properties:
                            reason:
                              type: string
                              enum:
                                - build_failed
                                - failed_to_land_on_chain
                                - unknown
                                - sanctioned_wallet_address
                            message:
                              type: string
                            revertData:
                              type: object
                              additionalProperties: {}
                          required:
                            - reason
                            - message
                        - type: object
                          properties:
                            reason:
                              type: string
                              enum:
                                - program_error
                            message:
                              type: string
                            revertData:
                              type: object
                              additionalProperties: {}
                            logs: {}
                          required:
                            - reason
                            - message
                        - type: object
                          properties:
                            reason:
                              type: string
                              enum:
                                - execution_reverted
                            message:
                              type: string
                            revertData:
                              type: object
                              additionalProperties: {}
                            revert:
                              type: object
                              properties:
                                type:
                                  type: string
                                  enum:
                                    - contract_call
                                    - wallet_authorization
                                    - wallet_deployment
                                reason:
                                  type: string
                                reasonData:
                                  oneOf:
                                    - type: string
                                    - type: object
                                      additionalProperties: {}
                                explorerLink:
                                  type: string
                                simulationLink:
                                  type: string
                              required:
                                - type
                                - reason
                          required:
                            - reason
                            - message
                      description: Error message if the transaction fails after submission
                    sendParams:
                      type: object
                      properties:
                        token:
                          type: string
                          description: The token locator that's being sent
                        params:
                          type: object
                          properties:
                            amount:
                              type: string
                              description: The amount of the token to send
                            recipient:
                              type: string
                              description: The recipient locator for the token
                            recipientAddress:
                              type: string
                              description: The recipient address for the token
                          required:
                            - recipient
                            - recipientAddress
                          description: The parameters for the send token transaction
                      required:
                        - token
                        - params
                    walletType:
                      type: string
                      enum:
                        - smart
                  required:
                    - chainType
                    - onChain
                    - id
                    - status
                    - createdAt
                    - walletType
                  description: The transaction for the signer
          title: Delegated Signer Response
          description: >-
            Complete delegated signer response including the signer and
            authorization transaction
          example:
            type: external-wallet
            address: DzaYNi6XtWt9DNwFV61bzWEiaSxfTgWbFDgFmurJzwdo
            locator: external-wallet:DzaYNi6XtWt9DNwFV61bzWEiaSxfTgWbFDgFmurJzwdo
            transaction:
              chainType: solana
              walletType: smart
              onChain:
                transaction: >-
                  4B9yzZoEV45cngasy9dP2MVxhZ2iro72eqdKitTj62pqFYHk4wVoR4NCc3xkEamWbFGXLjVotyPrDqEn11WUYHoq98b5aKCSDUrLWaQDZgb3xLxF1EvaY82Vui7Ntbv682tYnu5Ngnv4Eun1wrDJ6r4aRsUSQ3XF3jvNq8bRMn4HavBjPyErQSgXX9ytCDKntCEQcY3wfMHYbRFg5zgFU1QCqhuoLa5oBpZLCUYT8DCYu3Ado7W4xzP5aCAAwVd2tj8iAnwJEujQvBnr7wWkf2mCS1cNoCTbCFAvNVaVaau6vXBWKZqS7sDNmUD3KLQVqLwxhLLNeRuvUTkD5VQ5D21VcDiYWQWQTuYYAcQ3RUhn4Vt4ymijgRGbUXZHoeN26UHoGSBFJJ7gjqCruAtFXQZxHRDKSWN9jhYXugPYVVXSpGFA5BYWBuztUtEMF4u96tk6YTgPGdkTgrQybkNxRwbVCbpsKRG1kAbjQgBxDLAX89eMCZVbzWXnAgGA6aDBQPLAyQru8awZBDasrirnxCSQq9cWwMLePQGhY5gJZykswFKtyYF4CHeto
                lastValidBlockHeight: 343486121
              id: 30ef7527-eb5a-4862-92de-aa96947ee705
              status: pending
              approvals:
                required: 1
                pending:
                  - signer:
                      type: external-wallet
                      address: GsMTPi8utYnuWakS8uvPah3UKd13dWcAshirnNmXDr3d
                      locator: >-
                        external-wallet:GsMTPi8utYnuWakS8uvPah3UKd13dWcAshirnNmXDr3d
                    message: >-
                      2kwN1iuY6Y6Br2i5D1QphaS28H7vDdAiwtABgtRdYqjx7s85rRwqF9y6iVBdv9dDZ8F1JAZo8iQdFBAx2Eg9tL3P4sbAznPZgkZcGrbUSCe5jTZ7ULZrcSd377SGEjsZcwx7h7ozrUKB6FnjHB7wGaCqEeeUXE2CfCjC1SjEc8ZzZeyNmeEv5hJSkGsK62syoAE4V5ScZs7idhxXWzpeJiRt3wfWJRevr1pJY7BBd8HaEYurXtXqwCox1uzQnnuZTiUNu7cUWUajYXBWUae4NJGJxmtFJvqnPAa5HXB4nZWXMDdcBis4tQkLCfFT6GXMauQTFCaKmcMgLRh218n51nTNopR7gTaY66ysRH536wmxt9dLqkS9okG3HF5GEXufXPLX6iT7e7
                submitted: []
              createdAt: '2025-01-20T13:49:08.910Z'
        - allOf:
            - discriminator:
                propertyName: type
              oneOf:
                - type: object
                  properties:
                    type:
                      type: string
                      enum:
                        - passkey
                      description: Identifier for the Passkey signer type
                    id:
                      type: string
                      description: Credential ID from the WebAuthn registration response
                    name:
                      type: string
                      description: Human-readable name for the passkey
                    publicKey:
                      type: object
                      properties:
                        x:
                          type: string
                          description: X coordinate of the public key as a decimal string
                        'y':
                          type: string
                          description: Y coordinate of the public key as a decimal string
                      required:
                        - x
                        - 'y'
                      description: The public key coordinates from the WebAuthn credential
                    validatorContractVersion:
                      type: string
                      description: ERC-7579 webAuthn validator contract version
                    locator:
                      type: string
                      description: Unique identifier for locating this passkey signer
                  required:
                    - type
                    - id
                    - name
                    - publicKey
                    - validatorContractVersion
                    - locator
                  description: >-
                    Response schema for a registered Passkey signer including
                    validator contract details
                  title: Passkey Signer
                  example:
                    type: passkey
                    id: cWtP7gmZbd98HbKUuGXx5Q
                    name: hgranger
                    publicKey:
                      x: >-
                        38035223810536273945556366218149112558607829411547667975304293530457502824247
                      'y': >-
                        91117823763706733837104303008228095481082989039135234750508288790583476078729
                    validatorContractVersion: 0.2.0
                    locator: passkey:cWtP7gmZbd98HbKUuGXx5Q
                - type: object
                  properties:
                    type:
                      type: string
                      enum:
                        - api-key
                      description: Identifier for API key signer type
                    address:
                      oneOf:
                        - type: string
                          description: An EVM address string
                        - type: string
                          description: A base58-encoded Solana public key address
                        - type: string
                      description: The blockchain address of the custodial signer
                    locator:
                      type: string
                      description: The locator of the signer
                  required:
                    - type
                    - address
                    - locator
                  title: API Key Signer
                  description: >-
                    Configuration for a custodial signer managed by Crossmint.
                    Contact sales (https://www.crossmint.com/contact/sales) for
                    access.
                  example:
                    type: api-key
                    address: '0x1234567890123456789012345678901234567890'
                    locator: api-key:0x1234567890123456789012345678901234567890
                - type: object
                  properties:
                    type:
                      type: string
                      enum:
                        - external-wallet
                      description: Identifier for external wallet signer type
                    address:
                      type: string
                      description: The blockchain address of the external wallet
                    locator:
                      type: string
                      description: The locator of the signer
                  required:
                    - type
                    - address
                    - locator
                  title: External Wallet Signer
                  description: Configuration for an external wallet signer
                  example:
                    type: external-wallet
                    address: '0x1234567890123456789012345678901234567890'
                    locator: external-wallet:0x1234567890123456789012345678901234567890
                - type: object
                  properties:
                    type:
                      type: string
                      enum:
                        - email
                      description: Identifier for email signer type
                    email:
                      type: string
                      description: The email address for the signer
                    locator:
                      type: string
                      description: The locator of the signer
                    address:
                      oneOf:
                        - type: string
                          description: An EVM address string
                        - type: string
                      description: The address of the signer
                  required:
                    - type
                    - email
                    - locator
                    - address
                  title: Email Signer
                  description: Configuration for an email signer
                  example:
                    type: email
                    email: user@example.com
                    locator: email:user@example.com
                    address: 0x1234567890abcdef...
                - type: object
                  properties:
                    type:
                      type: string
                      enum:
                        - phone
                      description: Identifier for phone signer type
                    phone:
                      type: string
                      description: The phone number for the signer in E164 format
                    locator:
                      type: string
                      description: The locator of the signer
                    address:
                      oneOf:
                        - type: string
                          description: An EVM address string
                        - type: string
                      description: The address of the signer
                  required:
                    - type
                    - phone
                    - locator
                    - address
                  title: Phone Signer
                  description: Configuration for a phone signer
                  example:
                    type: phone
                    phone: '+1234567890'
                    locator: phone:+1234567890
                    address: 0x1234567890abcdef...
                - type: object
                  properties:
                    type:
                      type: string
                      enum:
                        - device
                      description: Identifier for device signer type
                    publicKey:
                      type: object
                      properties:
                        x:
                          type: string
                          description: The x coordinate of the p256 public key
                        'y':
                          type: string
                          description: The y coordinate of the p256 public key
                      required:
                        - x
                        - 'y'
                      description: The p256 public key of the device signer
                    locator:
                      type: string
                      description: The locator of the signer
                  required:
                    - type
                    - publicKey
                    - locator
                  title: Device Signer
                  description: Configuration for a device signer
                  example:
                    type: device
                    publicKey:
                      x: decimal_string_x
                      'y': decimal_string_y
                    locator: device:BIVmCqMz8QJB+se2kJEpGQ...
              description: Response schema for a registered signer
            - type: object
              properties:
                expiresAt:
                  oneOf:
                    - type: number
                      description: ISO 8601 formatted timestamp
                      example: '2024-01-01T00:00:00.000Z'
                    - type: string
                  description: The expiry date of the signer in ISO 8601 format
                  example: '2024-01-01T00:00:00.000Z'
                chains:
                  type: object
                  additionalProperties:
                    oneOf:
                      - type: object
                        properties:
                          status:
                            type: string
                            enum:
                              - success
                        required:
                          - status
                        title: Delegated Signer Approved
                        description: Delegated signer that has been approved for this chain
                      - type: object
                        properties:
                          status:
                            type: string
                            enum:
                              - pending
                              - awaiting-approval
                              - failed
                          id:
                            type: string
                            description: Unique identifier for the signature
                          approvals:
                            type: object
                            properties:
                              pending:
                                type: array
                                items:
                                  type: object
                                  properties:
                                    signer:
                                      discriminator:
                                        propertyName: type
                                      oneOf:
                                        - type: object
                                          properties:
                                            type:
                                              type: string
                                              enum:
                                                - external-wallet
                                            address:
                                              type: string
                                              description: The address of the external wallet
                                            locator:
                                              type: string
                                              description: >-
                                                The locator of the external wallet
                                                signer
                                          required:
                                            - type
                                            - address
                                            - locator
                                          title: External Wallet Signer
                                          description: Full External Wallet signer object
                                        - type: object
                                          properties:
                                            type:
                                              type: string
                                              enum:
                                                - passkey
                                            id:
                                              type: string
                                              description: The ID of the passkey
                                            locator:
                                              type: string
                                              description: The locator of the passkey signer
                                          required:
                                            - type
                                            - id
                                            - locator
                                          title: Passkey Signer
                                          description: Full Passkey signer object
                                        - type: object
                                          properties:
                                            type:
                                              type: string
                                              enum:
                                                - api-key
                                            address:
                                              type: string
                                              description: The address of the api key
                                            locator:
                                              type: string
                                              description: The locator of the api key signer
                                          required:
                                            - type
                                            - address
                                            - locator
                                          title: API Key Signer
                                          description: Full API Key signer object
                                        - type: object
                                          properties:
                                            type:
                                              type: string
                                              enum:
                                                - device
                                            publicKey:
                                              type: object
                                              properties:
                                                x:
                                                  type: string
                                                'y':
                                                  type: string
                                              required:
                                                - x
                                                - 'y'
                                              description: The p256 public key of the device signer
                                            locator:
                                              type: string
                                              description: The locator of the device signer
                                          required:
                                            - type
                                            - publicKey
                                            - locator
                                          title: Device Signer
                                          description: Full Device signer object
                                        - type: object
                                          properties:
                                            type:
                                              type: string
                                              enum:
                                                - email
                                            email:
                                              type: string
                                              format: email
                                            locator:
                                              type: string
                                          required:
                                            - type
                                            - email
                                            - locator
                                        - type: object
                                          properties:
                                            type:
                                              type: string
                                              enum:
                                                - phone
                                            phone:
                                              type: string
                                            locator:
                                              type: string
                                          required:
                                            - type
                                            - phone
                                            - locator
                                      description: >-
                                        The full signer object that's pending
                                        approval
                                    message:
                                      type: string
                                      description: The message that needs to be signed
                                  required:
                                    - signer
                                    - message
                                description: List of pending signatures
                              submitted:
                                type: array
                                items:
                                  type: object
                                  properties:
                                    signature:
                                      type: string
                                      description: The cryptographic signature
                                    submittedAt:
                                      oneOf:
                                        - type: number
                                          description: ISO 8601 formatted timestamp
                                          example: '2024-01-01T00:00:00.000Z'
                                        - type: string
                                      description: When the signature was submitted
                                      example: '2024-01-01T00:00:00.000Z'
                                    signer:
                                      discriminator:
                                        propertyName: type
                                      oneOf:
                                        - type: object
                                          properties:
                                            type:
                                              type: string
                                              enum:
                                                - external-wallet
                                            address:
                                              type: string
                                              description: The address of the external wallet
                                            locator:
                                              type: string
                                              description: >-
                                                The locator of the external wallet
                                                signer
                                          required:
                                            - type
                                            - address
                                            - locator
                                          title: External Wallet Signer
                                          description: Full External Wallet signer object
                                        - type: object
                                          properties:
                                            type:
                                              type: string
                                              enum:
                                                - passkey
                                            id:
                                              type: string
                                              description: The ID of the passkey
                                            locator:
                                              type: string
                                              description: The locator of the passkey signer
                                          required:
                                            - type
                                            - id
                                            - locator
                                          title: Passkey Signer
                                          description: Full Passkey signer object
                                        - type: object
                                          properties:
                                            type:
                                              type: string
                                              enum:
                                                - api-key
                                            address:
                                              type: string
                                              description: The address of the api key
                                            locator:
                                              type: string
                                              description: The locator of the api key signer
                                          required:
                                            - type
                                            - address
                                            - locator
                                          title: API Key Signer
                                          description: Full API Key signer object
                                        - type: object
                                          properties:
                                            type:
                                              type: string
                                              enum:
                                                - device
                                            publicKey:
                                              type: object
                                              properties:
                                                x:
                                                  type: string
                                                'y':
                                                  type: string
                                              required:
                                                - x
                                                - 'y'
                                              description: The p256 public key of the device signer
                                            locator:
                                              type: string
                                              description: The locator of the device signer
                                          required:
                                            - type
                                            - publicKey
                                            - locator
                                          title: Device Signer
                                          description: Full Device signer object
                                        - type: object
                                          properties:
                                            type:
                                              type: string
                                              enum:
                                                - email
                                            email:
                                              type: string
                                              format: email
                                            locator:
                                              type: string
                                          required:
                                            - type
                                            - email
                                            - locator
                                        - type: object
                                          properties:
                                            type:
                                              type: string
                                              enum:
                                                - phone
                                            phone:
                                              type: string
                                            locator:
                                              type: string
                                          required:
                                            - type
                                            - phone
                                            - locator
                                      description: >-
                                        The full signer object who submitted
                                        this signature
                                    message:
                                      type: string
                                      description: The message that was signed
                                    metadata:
                                      type: object
                                      properties:
                                        deviceInfo:
                                          type: string
                                        ipAddress:
                                          type: string
                                        userAgent:
                                          type: string
                                      description: >-
                                        Additional metadata about the signature
                                        submission
                                  required:
                                    - signature
                                    - submittedAt
                                    - signer
                                    - message
                                description: Record of all submitted signatures
                              required:
                                type: number
                                description: >-
                                  Number of required approvals for the
                                  transaction
                            required:
                              - pending
                              - submitted
                            description: >-
                              Complete approval data including requirements,
                              pending and submitted signatures
                        required:
                          - status
                          - id
                        title: Delegated Signer Awaiting Approval
                        description: >-
                          Delegated signer that is awaiting approval for this
                          chain
                  description: >-
                    Authorization status for each chain where the chain name is
                    the key and the signature request is the value
          title: Delegated Signer Response
          description: >-
            Complete delegated signer response including the signer and
            authorizations for each chain
          example:
            type: external-wallet
            address: '0x1234567890123456789012345678901234567890'
            locator: external-wallet:0x1234567890123456789012345678901234567890
            chains:
              polygon:
                status: active
              base:
                id: b984491a-5785-43c0-8811-45d46fe6e520
                status: awaiting-approval
                approvals:
                  pending: []
                  submitted:
                    - signer:
                        type: external-wallet
                        locator: >-
                          external-wallet:0x1234567890123456789012345678901234567890
                        address: '0x1234567890123456789012345678901234567890'
                      message: >-
                        0x1234567890123456789012345678901234567890123456789012345678901234
                      signature: >-
                        0x1234567890123456789012345678901234567890123456789012345678901234
                      submittedAt: '2024-01-01T00:00:00.000Z'
        - allOf:
            - discriminator:
                propertyName: type
              oneOf:
                - type: object
                  properties:
                    type:
                      type: string
                      enum:
                        - passkey
                      description: Identifier for the Passkey signer type
                    id:
                      type: string
                      description: Credential ID from the WebAuthn registration response
                    name:
                      type: string
                      description: Human-readable name for the passkey
                    publicKey:
                      type: object
                      properties:
                        x:
                          type: string
                          description: X coordinate of the public key as a decimal string
                        'y':
                          type: string
                          description: Y coordinate of the public key as a decimal string
                      required:
                        - x
                        - 'y'
                      description: The public key coordinates from the WebAuthn credential
                    validatorContractVersion:
                      type: string
                      description: ERC-7579 webAuthn validator contract version
                    locator:
                      type: string
                      description: Unique identifier for locating this passkey signer
                  required:
                    - type
                    - id
                    - name
                    - publicKey
                    - validatorContractVersion
                    - locator
                  description: >-
                    Response schema for a registered Passkey signer including
                    validator contract details
                  title: Passkey Signer
                  example:
                    type: passkey
                    id: cWtP7gmZbd98HbKUuGXx5Q
                    name: hgranger
                    publicKey:
                      x: >-
                        38035223810536273945556366218149112558607829411547667975304293530457502824247
                      'y': >-
                        91117823763706733837104303008228095481082989039135234750508288790583476078729
                    validatorContractVersion: 0.2.0
                    locator: passkey:cWtP7gmZbd98HbKUuGXx5Q
                - type: object
                  properties:
                    type:
                      type: string
                      enum:
                        - api-key
                      description: Identifier for API key signer type
                    address:
                      oneOf:
                        - type: string
                          description: An EVM address string
                        - type: string
                          description: A base58-encoded Solana public key address
                        - type: string
                      description: The blockchain address of the custodial signer
                    locator:
                      type: string
                      description: The locator of the signer
                  required:
                    - type
                    - address
                    - locator
                  title: API Key Signer
                  description: >-
                    Configuration for a custodial signer managed by Crossmint.
                    Contact sales (https://www.crossmint.com/contact/sales) for
                    access.
                  example:
                    type: api-key
                    address: '0x1234567890123456789012345678901234567890'
                    locator: api-key:0x1234567890123456789012345678901234567890
                - type: object
                  properties:
                    type:
                      type: string
                      enum:
                        - external-wallet
                      description: Identifier for external wallet signer type
                    address:
                      type: string
                      description: The blockchain address of the external wallet
                    locator:
                      type: string
                      description: The locator of the signer
                  required:
                    - type
                    - address
                    - locator
                  title: External Wallet Signer
                  description: Configuration for an external wallet signer
                  example:
                    type: external-wallet
                    address: '0x1234567890123456789012345678901234567890'
                    locator: external-wallet:0x1234567890123456789012345678901234567890
                - type: object
                  properties:
                    type:
                      type: string
                      enum:
                        - email
                      description: Identifier for email signer type
                    email:
                      type: string
                      description: The email address for the signer
                    locator:
                      type: string
                      description: The locator of the signer
                    address:
                      oneOf:
                        - type: string
                          description: An EVM address string
                        - type: string
                      description: The address of the signer
                  required:
                    - type
                    - email
                    - locator
                    - address
                  title: Email Signer
                  description: Configuration for an email signer
                  example:
                    type: email
                    email: user@example.com
                    locator: email:user@example.com
                    address: 0x1234567890abcdef...
                - type: object
                  properties:
                    type:
                      type: string
                      enum:
                        - phone
                      description: Identifier for phone signer type
                    phone:
                      type: string
                      description: The phone number for the signer in E164 format
                    locator:
                      type: string
                      description: The locator of the signer
                    address:
                      oneOf:
                        - type: string
                          description: An EVM address string
                        - type: string
                      description: The address of the signer
                  required:
                    - type
                    - phone
                    - locator
                    - address
                  title: Phone Signer
                  description: Configuration for a phone signer
                  example:
                    type: phone
                    phone: '+1234567890'
                    locator: phone:+1234567890
                    address: 0x1234567890abcdef...
                - type: object
                  properties:
                    type:
                      type: string
                      enum:
                        - device
                      description: Identifier for device signer type
                    publicKey:
                      type: object
                      properties:
                        x:
                          type: string
                          description: The x coordinate of the p256 public key
                        'y':
                          type: string
                          description: The y coordinate of the p256 public key
                      required:
                        - x
                        - 'y'
                      description: The p256 public key of the device signer
                    locator:
                      type: string
                      description: The locator of the signer
                  required:
                    - type
                    - publicKey
                    - locator
                  title: Device Signer
                  description: Configuration for a device signer
                  example:
                    type: device
                    publicKey:
                      x: decimal_string_x
                      'y': decimal_string_y
                    locator: device:BIVmCqMz8QJB+se2kJEpGQ...
              description: Response schema for a registered signer
            - type: object
              properties:
                permissions:
                  type: array
                  items:
                    discriminator:
                      propertyName: type
                    oneOf:
                      - type: object
                        properties:
                          type:
                            type: string
                            enum:
                              - external-policy
                          address:
                            type: string
                        required:
                          - type
                          - address
                        title: External Policy
                        description: Permission to use an external policy
                        example:
                          type: external-policy
                          address: >-
                            CCRBPM5HBMVLORGVXROAGIRHIGJC73PSFK3FKBB6KNRJBLHNJPBOI3AB
                  description: Optional array of permissions to be used for the signer
                  example:
                    - type: external-policy
                      address: CCRBPM5HBMVLORGVXROAGIRHIGJC73PSFK3FKBB6KNRJBLHNJPBOI3AB
                transaction:
                  type: object
                  properties:
                    chainType:
                      type: string
                      enum:
                        - stellar
                    onChain:
                      type: object
                      properties:
                        transaction:
                          type: object
                          properties:
                            method:
                              type: string
                            tx:
                              type: string
                          required:
                            - method
                            - tx
                          title: Stellar on-chain transaction
                          description: The Stellar Transaction Envelope
                        txId:
                          type: string
                          description: The transaction hash
                        ledger:
                          type: number
                          description: The ledger number where the transaction was included
                        expiration:
                          type: number
                          description: The expiration of the transaction
                        result:
                          description: The Transaction Result in XDR format
                        explorerLink:
                          type: string
                          description: Optional link to view the transaction in an explorer
                      required:
                        - transaction
                        - expiration
                      title: Stellar on-chain data
                    id:
                      type: string
                      description: Unique identifier for the transaction
                    status:
                      type: string
                      enum:
                        - awaiting-approval
                        - pending
                        - failed
                        - success
                      description: Current status of the transaction
                    approvals:
                      type: object
                      properties:
                        pending:
                          type: array
                          items:
                            type: object
                            properties:
                              signer:
                                discriminator:
                                  propertyName: type
                                oneOf:
                                  - type: object
                                    properties:
                                      type:
                                        type: string
                                        enum:
                                          - external-wallet
                                      address:
                                        type: string
                                        description: The address of the external wallet
                                      locator:
                                        type: string
                                        description: >-
                                          The locator of the external wallet
                                          signer
                                    required:
                                      - type
                                      - address
                                      - locator
                                    title: External Wallet Signer
                                    description: Full External Wallet signer object
                                  - type: object
                                    properties:
                                      type:
                                        type: string
                                        enum:
                                          - passkey
                                      id:
                                        type: string
                                        description: The ID of the passkey
                                      locator:
                                        type: string
                                        description: The locator of the passkey signer
                                    required:
                                      - type
                                      - id
                                      - locator
                                    title: Passkey Signer
                                    description: Full Passkey signer object
                                  - type: object
                                    properties:
                                      type:
                                        type: string
                                        enum:
                                          - api-key
                                      address:
                                        type: string
                                        description: The address of the api key
                                      locator:
                                        type: string
                                        description: The locator of the api key signer
                                    required:
                                      - type
                                      - address
                                      - locator
                                    title: API Key Signer
                                    description: Full API Key signer object
                                  - type: object
                                    properties:
                                      type:
                                        type: string
                                        enum:
                                          - device
                                      publicKey:
                                        type: object
                                        properties:
                                          x:
                                            type: string
                                          'y':
                                            type: string
                                        required:
                                          - x
                                          - 'y'
                                        description: The p256 public key of the device signer
                                      locator:
                                        type: string
                                        description: The locator of the device signer
                                    required:
                                      - type
                                      - publicKey
                                      - locator
                                    title: Device Signer
                                    description: Full Device signer object
                                  - type: object
                                    properties:
                                      type:
                                        type: string
                                        enum:
                                          - email
                                      email:
                                        type: string
                                        format: email
                                      locator:
                                        type: string
                                    required:
                                      - type
                                      - email
                                      - locator
                                  - type: object
                                    properties:
                                      type:
                                        type: string
                                        enum:
                                          - phone
                                      phone:
                                        type: string
                                      locator:
                                        type: string
                                    required:
                                      - type
                                      - phone
                                      - locator
                                description: The full signer object that's pending approval
                              message:
                                type: string
                                description: The message that needs to be signed
                            required:
                              - signer
                              - message
                          description: List of pending signatures
                        submitted:
                          type: array
                          items:
                            type: object
                            properties:
                              signature:
                                type: string
                                description: The cryptographic signature
                              submittedAt:
                                oneOf:
                                  - type: number
                                    description: ISO 8601 formatted timestamp
                                    example: '2024-01-01T00:00:00.000Z'
                                  - type: string
                                description: When the signature was submitted
                                example: '2024-01-01T00:00:00.000Z'
                              signer:
                                discriminator:
                                  propertyName: type
                                oneOf:
                                  - type: object
                                    properties:
                                      type:
                                        type: string
                                        enum:
                                          - external-wallet
                                      address:
                                        type: string
                                        description: The address of the external wallet
                                      locator:
                                        type: string
                                        description: >-
                                          The locator of the external wallet
                                          signer
                                    required:
                                      - type
                                      - address
                                      - locator
                                    title: External Wallet Signer
                                    description: Full External Wallet signer object
                                  - type: object
                                    properties:
                                      type:
                                        type: string
                                        enum:
                                          - passkey
                                      id:
                                        type: string
                                        description: The ID of the passkey
                                      locator:
                                        type: string
                                        description: The locator of the passkey signer
                                    required:
                                      - type
                                      - id
                                      - locator
                                    title: Passkey Signer
                                    description: Full Passkey signer object
                                  - type: object
                                    properties:
                                      type:
                                        type: string
                                        enum:
                                          - api-key
                                      address:
                                        type: string
                                        description: The address of the api key
                                      locator:
                                        type: string
                                        description: The locator of the api key signer
                                    required:
                                      - type
                                      - address
                                      - locator
                                    title: API Key Signer
                                    description: Full API Key signer object
                                  - type: object
                                    properties:
                                      type:
                                        type: string
                                        enum:
                                          - device
                                      publicKey:
                                        type: object
                                        properties:
                                          x:
                                            type: string
                                          'y':
                                            type: string
                                        required:
                                          - x
                                          - 'y'
                                        description: The p256 public key of the device signer
                                      locator:
                                        type: string
                                        description: The locator of the device signer
                                    required:
                                      - type
                                      - publicKey
                                      - locator
                                    title: Device Signer
                                    description: Full Device signer object
                                  - type: object
                                    properties:
                                      type:
                                        type: string
                                        enum:
                                          - email
                                      email:
                                        type: string
                                        format: email
                                      locator:
                                        type: string
                                    required:
                                      - type
                                      - email
                                      - locator
                                  - type: object
                                    properties:
                                      type:
                                        type: string
                                        enum:
                                          - phone
                                      phone:
                                        type: string
                                      locator:
                                        type: string
                                    required:
                                      - type
                                      - phone
                                      - locator
                                description: >-
                                  The full signer object who submitted this
                                  signature
                              message:
                                type: string
                                description: The message that was signed
                              metadata:
                                type: object
                                properties:
                                  deviceInfo:
                                    type: string
                                  ipAddress:
                                    type: string
                                  userAgent:
                                    type: string
                                description: >-
                                  Additional metadata about the signature
                                  submission
                            required:
                              - signature
                              - submittedAt
                              - signer
                              - message
                          description: Record of all submitted signatures
                        required:
                          type: number
                          description: Number of required approvals for the transaction
                      required:
                        - pending
                        - submitted
                      description: >-
                        Complete approval data including requirements, pending
                        and submitted signatures
                    createdAt:
                      oneOf:
                        - type: number
                          description: ISO 8601 formatted timestamp
                          example: '2024-01-01T00:00:00.000Z'
                        - type: string
                      description: ISO timestamp when the transaction was created
                      example: '2024-01-01T00:00:00.000Z'
                    completedAt:
                      oneOf:
                        - type: number
                          description: ISO 8601 formatted timestamp
                          example: '2024-01-01T00:00:00.000Z'
                        - type: string
                      description: ISO timestamp when the transaction reached finality
                      example: '2024-01-01T00:00:00.000Z'
                    error:
                      oneOf:
                        - type: object
                          properties:
                            reason:
                              type: string
                              enum:
                                - build_failed
                                - failed_to_land_on_chain
                                - unknown
                                - sanctioned_wallet_address
                            message:
                              type: string
                            revertData:
                              type: object
                              additionalProperties: {}
                          required:
                            - reason
                            - message
                        - type: object
                          properties:
                            reason:
                              type: string
                              enum:
                                - program_error
                            message:
                              type: string
                            revertData:
                              type: object
                              additionalProperties: {}
                            logs: {}
                          required:
                            - reason
                            - message
                        - type: object
                          properties:
                            reason:
                              type: string
                              enum:
                                - execution_reverted
                            message:
                              type: string
                            revertData:
                              type: object
                              additionalProperties: {}
                            revert:
                              type: object
                              properties:
                                type:
                                  type: string
                                  enum:
                                    - contract_call
                                    - wallet_authorization
                                    - wallet_deployment
                                reason:
                                  type: string
                                reasonData:
                                  oneOf:
                                    - type: string
                                    - type: object
                                      additionalProperties: {}
                                explorerLink:
                                  type: string
                                simulationLink:
                                  type: string
                              required:
                                - type
                                - reason
                          required:
                            - reason
                            - message
                      description: Error message if the transaction fails after submission
                    sendParams:
                      type: object
                      properties:
                        token:
                          type: string
                          description: The token locator that's being sent
                        params:
                          type: object
                          properties:
                            amount:
                              type: string
                              description: The amount of the token to send
                            recipient:
                              type: string
                              description: The recipient locator for the token
                            recipientAddress:
                              type: string
                              description: The recipient address for the token
                          required:
                            - recipient
                            - recipientAddress
                          description: The parameters for the send token transaction
                      required:
                        - token
                        - params
                    walletType:
                      type: string
                      enum:
                        - smart
                  required:
                    - chainType
                    - onChain
                    - id
                    - status
                    - createdAt
                    - walletType
                  description: The transaction for the signer
          title: Delegated Signer Response
          description: >-
            Complete delegated signer response including the signer and
            authorization transaction
          example:
            type: external-wallet
            address: GDUCX62IF76FFIYRNI25LJDS2V43QEZDY4YNF2DJWVIASN5LKX76Q4TW
            locator: >-
              external-wallet:GDUCX62IF76FFIYRNI25LJDS2V43QEZDY4YNF2DJWVIASN5LKX76Q4TW
            permissions:
              - type: external-policy
                address: CCRBPM5HBMVLORGVXROAGIRHIGJC73PSFK3FKBB6KNRJBLHNJPBOI3AB
            transaction:
              chainType: stellar
              walletType: smart
              onChain:
                transaction:
                  method: add_signer
                  tx: >-
[...]
